"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const notifiable_1 = require("../notifications/notifiable");
const notification_1 = require("../notifications/notification");
class CreditCardValidationContract extends notifiable_1.Notifiable {
    creditCardDateIsValid(val, property, message) {
        const patternDate = /^\d{1,2}\/\d{4}$/;
        if (!patternDate.test(val)) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
    creditCardDateIsGreaterThanToday(val, property, message) {
        const patternDate = /^\d{1,2}\/\d{4}$/;
        if (!patternDate.test(val)) {
            this.addNotification(new notification_1.Notification(property, message));
            return this;
        }
        const today = new Date();
        const someday = new Date();
        const date = val.split("/");
        someday.setFullYear(parseInt(date[1], 10), parseInt(date[0], 10), 1);
        if (someday < today) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
}
exports.CreditCardValidationContract = CreditCardValidationContract;
