"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const guid_typescript_1 = require("guid-typescript");
const notifiable_1 = require("../notifications/notifiable");
const notification_1 = require("../notifications/notification");
class GuidValidationContract extends notifiable_1.Notifiable {
    guidIsNotNullOrEmpty(val, property, message) {
        if (!val || val === null || typeof val === "undefined" || val.isEmpty() || !guid_typescript_1.Guid.isGuid(val)) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
    guidIsNullOrEmpty(val, property, message) {
        if (val !== null || val) {
            if (!guid_typescript_1.Guid.isGuid(val) || !val.isEmpty()) {
                this.addNotification(new notification_1.Notification(property, message));
            }
        }
        return this;
    }
    guidIsNotEmpty(val, property, message) {
        if (val || val !== null) {
            if (!guid_typescript_1.Guid.isGuid(val) || val.isEmpty()) {
                this.addNotification(new notification_1.Notification(property, message));
            }
        }
        return this;
    }
    guidIsEmpty(val, property, message) {
        if (val === null || !val || !guid_typescript_1.Guid.isGuid(val) || !(val.isEmpty())) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
    guidAreEquals(val, comparer, property, message) {
        if (!val.equals(comparer)) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
    guidAreNotEquals(val, comparer, property, message) {
        if (val.equals(comparer)) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
}
exports.GuidValidationContract = GuidValidationContract;
