"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const notifiable_1 = require("../notifications/notifiable");
const notification_1 = require("../notifications/notification");
class ObjectValidationContract extends notifiable_1.Notifiable {
    objectIsNotNull(val, property, message) {
        if (typeof val === "undefined" || val === null || !val) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
    objectIsNull(val, property, message) {
        if (typeof val === "undefined" || val !== null || val) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
    objectAreEquals(val, compare, property, message) {
        if (val && typeof val.equals === "function" && !val.equals(compare)) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        else if (val !== compare) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
    objectAreNotEquals(val, compare, property, message) {
        if (val && typeof val.equals === "function" && val.equals(compare)) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        else if (val === compare) {
            this.addNotification(new notification_1.Notification(property, message));
        }
        return this;
    }
}
exports.ObjectValidationContract = ObjectValidationContract;
