"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const notifiable_1 = require("../notifications/notifiable");
const boolean_validation_contract_1 = require("./boolean-validation-contract");
const credit_card_validation_contract_1 = require("./credit-card-validation-contract");
const date_validation_contract_1 = require("./date-validation-contract");
const guid_validator_contract_1 = require("./guid-validator-contract");
const number_validation_contract_1 = require("./number-validation-contract");
const object_validation_contract_1 = require("./object-validation-contract");
const string_validation_contract_1 = require("./string-validation-contract");
class ValidationContract extends notifiable_1.Notifiable {
    constructor() {
        super();
        this.requires = () => this;
    }
    concat(notifiable) {
        if (notifiable.invalid) {
            this.addNotifications(notifiable.notifications);
        }
        return this;
    }
}
exports.ValidationContract = ValidationContract;
applyMixins(ValidationContract, [
    string_validation_contract_1.StringValidationContract,
    number_validation_contract_1.NumberValidationContract,
    guid_validator_contract_1.GuidValidationContract,
    object_validation_contract_1.ObjectValidationContract,
    boolean_validation_contract_1.BooleanValidationContract,
    credit_card_validation_contract_1.CreditCardValidationContract,
    date_validation_contract_1.DateValidationContract
]);
////////////////////////////////////////
// In your runtime library somewhere
////////////////////////////////////////
function applyMixins(derivedCtor, baseCtors) {
    baseCtors.forEach((baseCtor) => {
        Object.getOwnPropertyNames(baseCtor.prototype).forEach((name) => {
            derivedCtor.prototype[name] = baseCtor.prototype[name];
        });
    });
}
